bug fixes for jessie & stretch
[automated-distro-installer] / fai / config / scripts / DEBIAN / 30-interface
index 9883731fd90efbaa728267d099d3755e6ebc554e..6f2251a1452ed9938cb468ca62e7099b22651988 100755 (executable)
@@ -1,26 +1,66 @@
 #! /bin/bash
 
+# modified from upstream fai example
 error=0; trap 'error=$(($?>$error?$?:$error))' ERR # save maximum error code
 
+if ! ifclass VM && ! ifclass STABLE; then
+    # get persistent interface name. Note, these class conditions
+    # will need to get modified for new oses. testing vm doesn't use
+    # it right now, but other vms do I'm sure.
+    for field in ID_NET_NAME_FROM_DATABASE \
+                     ID_NET_NAME_ONBOARD \
+                     ID_NET_NAME_SLOT \
+                     ID_NET_NAME_PATH \
+                     ID_NET_NAME_MAC; do
+        name=$(udevadm info /sys/class/net/$NIC1 | sed -rn "s/^E: $field=(.+)/\1/p")
+        if [[ $name ]]; then
+            NIC1=$name
+            break
+        fi
+    done
+    if [[ ! $name ]]; then
+        echo "$0: error: could not find systemd predictable network name"
+        exit 1
+    fi
+fi
+
 if ifclass DHCPC && [ $FAI_ACTION = "install" -o $FAI_ACTION = "dirinstall" ]
 then
-    cat > $target/etc/network/interfaces <<-EOF
-       # generated by FAI
-       auto lo $NIC1
-       iface lo inet loopback
-       iface $NIC1 inet dhcp
+    if ifclass VM; then
+        cat > $target/etc/network/interfaces <<-EOF
+        # generated by FAI
+        auto lo $NIC1
+        iface lo inet loopback
+        iface $NIC1 inet dhcp
 EOF
+    else
+        cat > $target/etc/network/interfaces <<-EOF
+        # generated by FAI
+        auto lo br0
+        iface lo inet loopback
+        iface $NIC1 inet manual
+        # make a bridge by default so we can have bridged vms.
+        # Some example I read had stp on, but i don't need stp,
+        # and it causes a vm to fail pxe boot, presumably unless
+        # you add some delay.
+        # http://wiki.libvirt.org/page/PXE_boot_%28or_dhcp%29_on_guest_failed
+        iface br0 inet dhcp
+          bridge_ports $NIC1
+          bridge_stp off
+          bridge_maxwait 0
+EOF
+    fi
 elif [ $FAI_ACTION = "install" -o $FAI_ACTION = "dirinstall" ]
 then
-      [ -n "$IPADDR" ] && cat > $target/etc/network/interfaces <<-EOF
-       # generated by FAI
-       auto lo $NIC1
-       iface lo inet loopback
-       iface $NIC1 inet static
-         address $IPADDR
-         netmask $NETMASK
-         broadcast $BROADCAST
-         gateway $GATEWAYS
+    [ -n "$IPADDR" ] && cat > $target/etc/network/interfaces <<-EOF
+        # generated by FAI
+        auto lo $NIC1
+        iface lo inet loopback
+        iface $NIC1 inet static
+          address $IPADDR
+          netmask $NETMASK
+          broadcast $BROADCAST
+          gateway $GATEWAYS
 EOF
     [ -n "$NETWORK" ] && echo "localnet $NETWORK" > $target/etc/networks
     if [ ! -L $target/etc/resolv.conf -a -e /etc/resolv.conf ]; then